using Raylib;
using static Raylib.Raylib;

public partial class core_drop_files
{
    /*******************************************************************************************
    *
    *   raylib [core] example - Windows drop files
    *
    *   This example only works on platforms that support drag ref drop (Windows, Linux, OSX, Html5?)
    *
    *   This example has been created using raylib 1.3 (www.raylib.com)
    *   raylib is licensed under an unmodified zlib/libpng license (View raylib.h for details)
    *
    *   Copyright (c) 2015 Ramon Santamaria (@raysan5)
    *
    ********************************************************************************************/
    
    
    public static int Main()
    {
        // Initialization
        //--------------------------------------------------------------------------------------
        int screenWidth = 800;
        int screenHeight = 450;
    
        InitWindow(screenWidth, screenHeight, "raylib [core] example - drop files");
        
        int count = 0;
        string[] droppedFiles = { };
        
        SetTargetFPS(60);
        //--------------------------------------------------------------------------------------
    
        // Main game loop
        while (!WindowShouldClose())    // Detect window close button or ESC key
        {
            // Update
            //----------------------------------------------------------------------------------
            if (IsFileDropped())
            {
                droppedFiles = GetDroppedFiles(ref count);
            }
            //----------------------------------------------------------------------------------
    
            // Draw
            //----------------------------------------------------------------------------------
            BeginDrawing();
    
                ClearBackground(RAYWHITE);
    
                if (count == 0) DrawText("Drop your files to this window!", 100, 40, 20, DARKGRAY);
                else
                {
                    DrawText("Dropped files:", 100, 40, 20, DARKGRAY);
                    
                    for (int i = 0; i < count; i++)
                    {
                        if (i%2 == 0) DrawRectangle(0, 85 + 40*i, screenWidth, 40, Fade(LIGHTGRAY, 0.5f));
                        else DrawRectangle(0, 85 + 40*i, screenWidth, 40, Fade(LIGHTGRAY, 0.3f));
                        
                        DrawText(droppedFiles[i], 120, 100 + 40*i, 10, GRAY);
                    }
                    
                    DrawText("Drop new files...", 100, 110 + 40*count, 20, DARKGRAY);
                }
    
            EndDrawing();
            //----------------------------------------------------------------------------------
        }
    
        // De-Initialization
        //--------------------------------------------------------------------------------------
        ClearDroppedFiles();    // Clear internal buffers
        
        CloseWindow();          // Close window and OpenGL context
        //--------------------------------------------------------------------------------------
    
        return 0;
    }    
}
